SystemOrganization addCategory: #Proxies!
SystemOrganization addCategory: #'Proxies-Serializers'!
SystemOrganization addCategory: #'Proxies-Objects-CannotInterpret'!
SystemOrganization addCategory: #'Proxies-Objects'!
SystemOrganization addCategory: #'Proxies-Methods'!
SystemOrganization addCategory: #'Proxies-Errors'!
SystemOrganization addCategory: #'Proxies-Classes'!

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/13/2010 22:21'!
initialize 
	self addClassVarName: 'CurrentNumber'.
	self addClassVarName: 'IsRunnintTests'.
	CurrentNumber := 0.! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:44'!
installOn: aClass selector: aSel
	^ (self on: aClass selector: aSel)! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/13/2011 20:26'!
isRunningTest
	IsRunnintTests isNil ifTrue: [IsRunnintTests := true].
	^ IsRunnintTests ! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'mariano 11/26/2010 17:38'!
mareaAllInstalledProxies
	^ (1 to: self mareaCurrentNumber) select: [:each | each mareaIsProxyInstalled ] 
! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/26/2010 15:07'!
mareaAllInstalledProxiesCount
	^ self mareaAllInstalledProxies size! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'mariano 11/26/2010 17:37'!
mareaCurrentNumber
	CurrentNumber isNil ifTrue: [ CurrentNumber := 0 ].
	^ CurrentNumber
! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'mariano 11/26/2010 17:37'!
mareaNextNumber
	CurrentNumber := self mareaCurrentNumber + 1.
	^ CurrentNumber
! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/30/2010 17:30'!
mareaResetNumber.
	CurrentNumber := nil! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'mariano 11/27/2010 16:14'!
mareaUninstallIfNeededAllInstances
	(1 to: self mareaCurrentNumber) do: [:each | each mareaUninstallIfNeeded ] 
! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/1/2010 17:39'!
mareaUninstallIfNeededAllInstancesWithTracing: aLogger
	| counter |
	counter := 0.
	self mareaAllInstalledProxies do: [:instance| 
		(counter \\ 5000) isZero ifTrue: [
			aLogger log: ''.
			aLogger log: SmalltalkImage current vmStatisticsReportString.
			aLogger log: ''.
		]. 
	counter := counter + 1.
	instance mareaUninstallIfNeeded
	].! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 18:28'!
on: aMethodReference
	^self mareaNextNumber mareaInstallFor: aMethodReference 
	! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:44'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 17:37'!
runningTest: aBoolean
	IsRunnintTests := aBoolean  ! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/13/2010 22:38'!
class
	((self mareaClass isRunningTest) or: [self mareaIsProxyInstalled not])
		ifTrue: [^ self mareaClass ]
		ifFalse: [ ^ self mareaUninstall class ].
	! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/24/2010 11:52'!
doesNotUnderstand: aMessage
	self mareaIsProxyInstalled 
		ifTrue: [ ^ CompiledMethodProxyHandler mareaHandleDoesNotUnderstand: aMessage forProxy: self]
		ifFalse: [ ^ super doesNotUnderstand: aMessage ].
	! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/17/2010 18:56'!
flushCache
	"Tell the interpreter to remove all references to this method from its method lookup cache, if it has one.  This primitive must be called whenever a method is defined or removed.
	NOTE:  Only one of two selective flush methods needs to be used.
	Squeak 2.2 and earlier uses 119 (See Symbol flushCache).
	Squeak 2.3 and later uses 116 (See CompiledMethod flushCache)."

	<primitive: 116>
! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 11:26'!
mareaFileName
	^ self asString, '.swap'! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/14/2011 19:17'!
mareaFileNameFor: aCompiledMethod
	^ self asString! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 15:14'!
mareaInstallFor: aMethodReference
	CompiledMethodProxyHandler mareaInstallFor: aMethodReference andProxy: self
	! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/25/2010 16:51'!
mareaIsProxy
	^ true! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/24/2010 11:36'!
mareaIsProxyInstalled 
	^ FileDirectory default isAFileNamed: self mareaFileName! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/24/2010 12:15'!
mareaMarkAsUninstalled
	"We don't need to do anything for SmallInteger since to detect if it is uninstalled we check the existance off the file, which is removed during the uninstall'"! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 12:15'!
mareaStoreFileNameIfNecessary: aFileName! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 15:14'!
mareaUninstall
	^ CompiledMethodProxyHandler mareaUninstallForProxy: self
! !

!SmallInteger methodsFor: '*Proxies' stamp: 'mariano 11/27/2010 16:15'!
mareaUninstallIfNeeded
	^ CompiledMethodProxyHandler mareaUninstallIfNeeded: self
! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/24/2010 16:34'!
run: aSelector with: arguments in: aReceiver
	^ CompiledMethodProxyHandler mareaHandleRun: aSelector with: arguments in: aReceiver forProxy: self
	! !

!Behavior methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/13/2011 22:50'!
methodDict
	methodDict == nil ifTrue: ["self manageMDFault" ^ self emptyMethodDictionary  ].
	^ methodDict! !

!CompiledMethod methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/17/2010 21:58'!
mareaPrintString 
	^ self methodClass asString, '>>', self selector.! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/13/2010 20:12'!
associationsDo: aBlock 
	| key |
	tally = 0 ifTrue: [^ self].
	1 to: self basicSize do:
		[:i | (key := self basicAt: i) == nil ifFalse:
			[ ((array at: i) mareaIsProxy) ifTrue: [(array at: i) mareaUninstall].
			aBlock value: (Association key: key
									value: (array at: i))]]! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/13/2010 20:13'!
at: key ifAbsent: aBlock

    | index value |
    index := self findElementOrNil: key.
    (self basicAt: index) == nil ifTrue: [ ^ aBlock value ].
    value := array at: index.
    (value mareaIsProxy) ifTrue: [value mareaUninstall].
    ^ array at: index! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 19:01'!
mareaAt: key 
	"Answer the value associated with the key."

	^ self mareaAt: key ifAbsent: [self errorKeyNotFound]! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 19:00'!
mareaAt: key ifAbsent: aBlock

	| index |
	index := self findElementOrNil: key.
	(self basicAt: index) == nil ifTrue: [ ^ aBlock value ].
	^ array at: index! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/2/2010 11:31'!
mareaUninstallIfProxy: value
	(value mareaIsProxy) ifTrue: [value mareaUninstall].! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/13/2010 20:12'!
valuesDo: aBlock 
	| value |
	tally = 0 ifTrue: [^ self].
	1 to: self basicSize do:
		[:i | (value := array at: i) == nil
			ifFalse: [
				(value mareaIsProxy) ifTrue: [value mareaUninstall].
				aBlock value: (array at: i)]]
		! !

ProtoObject subclass: #AbstractCompiledMethodProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Methods'!

AbstractCompiledMethodProxy class
	instanceVariableNames: 'IsRunnintTests'!

AbstractCompiledMethodProxy class
	instanceVariableNames: 'IsRunnintTests'!

!AbstractCompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 12/1/2010 18:07'!
installOn: aClass selector: aSel
	^ (self on: aClass selector: aSel)! !

!AbstractCompiledMethodProxy classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/13/2011 20:26'!
isRunningTest
	IsRunnintTests isNil ifTrue: [IsRunnintTests := true].
	^ IsRunnintTests ! !

!AbstractCompiledMethodProxy classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/1/2010 18:06'!
mareaAllInstalledProxies
	^ self allInstances select: [:each | each mareaIsProxyInstalled ]
 
! !

!AbstractCompiledMethodProxy classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/1/2010 18:06'!
mareaAllInstalledProxiesCount
	^ self mareaAllInstalledProxies size
	
 
! !

!AbstractCompiledMethodProxy classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/1/2010 18:06'!
mareaUninstallIfNeededAllInstances
	self allInstancesDo: [:each | each mareaUninstallIfNeeded ]
 
! !

!AbstractCompiledMethodProxy classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/1/2010 18:06'!
mareaUninstallIfNeededAllInstancesWithTracing: aLogger
	| counter |
	counter := 0.
	self allInstancesDo: [:instance| 
		(counter \\ 5000) isZero ifTrue: [
			aLogger log: ''.
			aLogger log: SmalltalkImage current vmStatisticsReportString.
			aLogger log: ''.
		]. 
	counter := counter + 1.
	instance mareaUninstallIfNeeded
	].
! !

!AbstractCompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 12/1/2010 18:07'!
on: aMethodReference
	^self new mareaInstallFor: aMethodReference ! !

!AbstractCompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 12/1/2010 18:07'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!AbstractCompiledMethodProxy classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/1/2010 18:07'!
runningTest: aBoolean
	IsRunnintTests := aBoolean  ! !

!AbstractCompiledMethodProxy methodsFor: 'class membership' stamp: 'MarianoMartinezPeck 3/14/2011 16:45'!
class
	((self mareaClass isRunningTest) or: [self mareaIsProxyInstalled not])
		ifTrue: [ Transcript show: '-----fffff sii '.  (self mareaClass isRunningTest) ifTrue: [Transcript show: '---runn tru'].
			  (self mareaIsProxyInstalled not) ifTrue: [Transcript show: '---insta true'].  ^ self mareaClass ]
		ifFalse: [ Transcript show: '---noooo.'. ^ self mareaUninstall class ].
	! !

!AbstractCompiledMethodProxy methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 11/30/2010 11:25'!
doesNotUnderstand: aMessage
	self mareaIsProxyInstalled 
		ifTrue: [ ^ CompiledMethodProxyHandler mareaHandleDoesNotUnderstand: aMessage forProxy: self]
		ifFalse: [ ^ super doesNotUnderstand: aMessage ].
	
	

! !

!AbstractCompiledMethodProxy methodsFor: 'objects as mehods API' stamp: 'MarianoMartinezPeck 11/30/2010 11:25'!
flushCache
	"Tell the interpreter to remove all references to this method from its method lookup cache, if it has one.  This primitive must be called whenever a method is defined or removed.
	NOTE:  Only one of two selective flush methods needs to be used.
	Squeak 2.2 and earlier uses 119 (See Symbol flushCache).
	Squeak 2.3 and later uses 116 (See CompiledMethod flushCache)."

	<primitive: 116>
! !

!AbstractCompiledMethodProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 11/30/2010 11:25'!
mareaInstallFor: aMethodReference
	CompiledMethodProxyHandler mareaInstallFor: aMethodReference andProxy: self
	! !

!AbstractCompiledMethodProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 11/30/2010 11:25'!
mareaIsProxy
	^ true! !

!AbstractCompiledMethodProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 11/30/2010 11:25'!
mareaUninstall
	^ CompiledMethodProxyHandler mareaUninstallForProxy: self
! !

!AbstractCompiledMethodProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 11/30/2010 11:25'!
mareaUninstallIfNeeded
	^ CompiledMethodProxyHandler mareaUninstallIfNeeded: self
! !

!AbstractCompiledMethodProxy methodsFor: 'objects as mehods API' stamp: 'MarianoMartinezPeck 11/30/2010 11:25'!
run: aSelector with: arguments in: aReceiver
	^ CompiledMethodProxyHandler mareaHandleRun: aSelector with: arguments in: aReceiver forProxy: self
	! !

AbstractCompiledMethodProxy subclass: #CompiledMethodProxy
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Methods'!

!CompiledMethodProxy classSide methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/13/2010 23:28'!
initialize
	self becomeCompact.! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/23/2010 12:05'!
mareaFileName
	^ fileName! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/14/2011 19:17'!
mareaFileNameFor: aCompiledMethod
	^ aCompiledMethod mareaPrintString! !

!CompiledMethodProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 11/24/2010 11:33'!
mareaIsProxyInstalled
	^ fileName isNil not! !

!CompiledMethodProxy methodsFor: 'updating' stamp: 'MarianoMartinezPeck 11/24/2010 12:10'!
mareaMarkAsUninstalled
	fileName := nil.! !

!CompiledMethodProxy methodsFor: 'updating' stamp: 'MarianoMartinezPeck 11/23/2010 12:15'!
mareaStoreFileNameIfNecessary: aFileName
	fileName := aFileName! !

AbstractCompiledMethodProxy subclass: #CompiledMethodProxySmallInteger
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Methods'!

!CompiledMethodProxySmallInteger classSide methodsFor: 'initialization' stamp: 'MarianoMartinezPeck 12/13/2010 23:28'!
initialize
	self becomeCompact.! !

!CompiledMethodProxySmallInteger methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 11:57'!
mareaFileName
	^ number asString, '.swap'! !

!CompiledMethodProxySmallInteger methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/14/2011 19:18'!
mareaFileNameFor: aCompiledMethod
	number := SmallInteger mareaNextNumber.
	^  number asString! !

!CompiledMethodProxySmallInteger methodsFor: 'testing' stamp: 'MarianoMartinezPeck 11/30/2010 11:38'!
mareaIsProxyInstalled
	^ number isNil not! !

!CompiledMethodProxySmallInteger methodsFor: 'updating' stamp: 'MarianoMartinezPeck 11/30/2010 11:38'!
mareaMarkAsUninstalled
	number := nil.! !

!CompiledMethodProxySmallInteger methodsFor: 'updating' stamp: 'MarianoMartinezPeck 11/30/2010 11:39'!
mareaStoreFileNameIfNecessary: aFileName
! !

ProtoObject subclass: #ClassProxy
	instanceVariableNames: 'superclass methodDict format fileName result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Classes'!

ClassProxy class
	instanceVariableNames: 'IsRunnintTests'!

ClassProxy class
	instanceVariableNames: 'IsRunnintTests'!

!ClassProxy classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 1/17/2011 15:20'!
installOn: aClass
	^self new mareaInstallFor: aClass ! !

!ClassProxy classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/13/2011 20:26'!
isRunningTest
	IsRunnintTests isNil ifTrue: [IsRunnintTests := true].
	^ IsRunnintTests ! !

!ClassProxy classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 1/17/2011 16:41'!
runningTest: aBoolean
	IsRunnintTests := aBoolean  ! !

!ClassProxy methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 1/17/2011 17:09'!
doesNotUnderstand: aMessage
	self mareaIsProxyInstalled 
		ifTrue: [ ^ ClassProxyHandler mareaHandleDoesNotUnderstand: aMessage forProxy: self]
		ifFalse: [ ^ super doesNotUnderstand: aMessage ].
	! !

!ClassProxy methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 3/13/2011 12:45'!
initialize
	super initialize.
	superclass := ClassProxySuperclass.
	methodDict := nil.
	fileName := nil.! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 1/17/2011 17:05'!
mareaFileName
	^ fileName! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/14/2011 19:18'!
mareaFileNameFor: aClass
	^ aClass name! !

!ClassProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 1/17/2011 15:32'!
mareaInstallFor: aClass
	ClassProxyHandler mareaInstallFor: aClass andProxy: self
	! !

!ClassProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 1/17/2011 15:53'!
mareaIsProxy
	^ true! !

!ClassProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 1/17/2011 17:05'!
mareaIsProxyInstalled
	^  fileName isNil not! !

!ClassProxy methodsFor: 'updating' stamp: 'MarianoMartinezPeck 1/17/2011 17:05'!
mareaMarkAsUninstalled
	fileName := nil.! !

!ClassProxy methodsFor: 'updating' stamp: 'MarianoMartinezPeck 1/17/2011 16:05'!
mareaStoreFileNameIfNecessary: aFileName
	fileName := aFileName! !

!ClassProxy methodsFor: 'updating' stamp: 'MarianoMartinezPeck 1/19/2011 11:12'!
mareaStoreFileNameIfNecessary: aFileName result: aResult
	fileName := aFileName.
	result := aResult! !

!ClassProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 1/17/2011 15:53'!
mareaUninstall
	^ ClassProxyHandler mareaUninstallForProxy: self
! !

!ClassProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 1/17/2011 17:09'!
mareaUninstallIfNeeded
	^ ClassProxyHandler mareaUninstallIfNeeded: self
! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 1/19/2011 11:16'!
result 
	^ result! !

!ClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/23/2011 15:29'!
result: aResult
	result := aResult ! !

ProtoObject subclass: #ClassProxyHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Classes'!

ClassProxyHandler class
	instanceVariableNames: 'MareaSerializer'!

ClassProxyHandler class
	instanceVariableNames: 'MareaSerializer'!

!ClassProxyHandler classSide methodsFor: 'constants' stamp: 'MarianoMartinezPeck 1/17/2011 15:36'!
loopTreshhold
	^ 10! !

!ClassProxyHandler classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 3/13/2011 12:37'!
mareaCheckLoop
	| ctxt runWithInMethodProxy runWithInMethodProxyReceiver proxySender found startingPoint loopCounter |

	ctxt := thisContext.
	loopCounter := 0.
	
	ctxt sender ifNil: [^ self].
	ctxt sender sender ifNil: [^ self].
	ctxt sender sender sender ifNil: [^ self].
	
	runWithInMethodProxy := ctxt sender sender method.
	runWithInMethodProxyReceiver :=  ctxt sender sender receiver. 
	proxySender := ctxt sender sender sender method.
	startingPoint := ctxt sender sender sender.
	
"	ToolSet inspect: ctxt sender sender sender label: 'where to start'. 
	ToolSet inspect: runWithInMethodProxy label: 'runWithInMethodProxy'.
	ToolSet inspect: runWithInMethodProxyReceiver label: 'runWithInMethodProxyReceiver'.
	ToolSet inspect: proxySender label: 'proxySender'."
	
	[startingPoint isNil ifFalse: [
		loopCounter := loopCounter + 1.
		found := startingPoint findContextSuchThat: [:aContext | 
			(aContext sender isNil not) and:  [
				(aContext sender method == proxySender) 
				and: [
					(runWithInMethodProxyReceiver == aContext receiver)
						and: [aContext method == runWithInMethodProxy ]]
			]
		].
		 found isNil ifFalse: [ startingPoint := found sender].
		]
	] doWhileTrue: [ (found isNil not and: [loopCounter < self loopTreshhold ]) and: [startingPoint isNil not] ].
	
	

	
	(loopCounter = self loopTreshhold) ifTrue: [ 
		self mareaLog: 'LOOP ---- ', ctxt sender sender tempsAndValues asString. 
		(PossibleLoopDetection with: ctxt sender sender tempsAndValues)
		signal: 'It is possible that a proxy that was needed to swap is, was swapped out.' ].
! !

!ClassProxyHandler classSide methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 1/17/2011 17:04'!
mareaHandleCannotInterpret: aMessage for: aProxy receiver: anObject
	| answer |
	self mareaLog: 'cannotInterpret: ', aMessage selector.
	self mareaUninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := aMessage sendTo: anObject.
	self mareaLog: 'The message was sent to the original object'.
	^ answer 
! !

!ClassProxyHandler classSide methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 1/17/2011 16:58'!
mareaHandleDoesNotUnderstand: aMessage forProxy: aProxy
	| oldClass answer |
	self mareaCheckLoop.
	self mareaLog: aProxy mareaClass name, ' dnu: ', aMessage selector.
	oldClass := self mareaUninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := aProxy perform: aMessage selector withArguments: aMessage arguments.
	self mareaLog: 'The message was sent to the original object'.
	^ answer.! !

!ClassProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/14/2011 19:43'!
mareaInstallFor: aClass andProxy: aProxy
	| className  |
	["The other alternative is being able to create proxies for profies, but the proxy 
	handlers expect a Class and not a proxy."
	aClass mareaIsProxy.
	] whileTrue: [aClass mareaUninstall].

	className := aClass name.
	self mareaLog: 'The class ', aClass name, ' is being wrapped'. 
	self mareaWriteObjectOnDisk: aClass andProxy: aProxy.
	aProxy become: aClass.
	self flag: #fixit.
	"THIS MUST BE REMOVED WHEN THE SERIALIZATION OF A CLASS IS WORKING"
	"and the become should be:  aClass becomeForward: aProxy   so that nobody else points to the class and it can be garbage collected"
	aClass result: aProxy.
	self mareaLog: 'The class ', className , ' was wrapped'.
	! !

!ClassProxyHandler classSide methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 2/23/2011 16:38'!
mareaLoadClassFor: aProxy
	self flag: #fixit.
	"THIS MUST BE REMOVED WHEN THE SERIALIZATION OF A CLASS IS WORKING"
	^ aProxy result
"	^ self mareaSerializer mareaUnserializeClassFrom: aProxy mareaFileName result: aProxy result.
"	! !

!ClassProxyHandler classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 1/17/2011 15:36'!
mareaRemoveFile: aFileName
	FileDirectory default deleteFileNamed: aFileName
	
! !

!ClassProxyHandler classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 1/17/2011 15:36'!
mareaSerializer
	MareaSerializer isNil ifTrue: [MareaSerializer := ReferenceStreamMareaSerializer new].
	^ MareaSerializer! !

!ClassProxyHandler classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 1/17/2011 15:36'!
mareaSerializer: aMareaSerializer
	MareaSerializer := aMareaSerializer new! !

!ClassProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 1/17/2011 15:36'!
mareaUninstallForProxy: aProxy
	^ self mareaUninstallForProxy: aProxy ifNotInstalled: [ ProxyIsNotInstalled signal: 'The proxy is not installed. '].! !

!ClassProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 2/23/2011 15:43'!
mareaUninstallForProxy: aProxy ifNotInstalled: errorBLock
	| oldClass |
	self mareaLog: 'Starting to uninstall.'.
	aProxy mareaIsProxyInstalled ifFalse: [ errorBLock value ].
	self mareaLog: 'Trying to load.'.
	oldClass := self mareaLoadClassFor: aProxy.
	self mareaLog: 'The class ', oldClass name, ' was loaded form file.'.
	aProxy become: oldClass.
	"now oldClass points to the proxy and aProxy points to the old class"
	self mareaLog: 'The Proxy for ', aProxy name, ' was uninstalled.'.
	self mareaRemoveFile: oldClass mareaFileName.
	oldClass mareaMarkAsUninstalled.
	^ aProxy.  
! !

!ClassProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 1/17/2011 15:36'!
mareaUninstallIfNeeded: aProxy
	^ [self mareaUninstallForProxy: aProxy] on: ProxyIsNotInstalled do: [].! !

!ClassProxyHandler classSide methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 3/14/2011 19:44'!
mareaWriteObjectOnDisk: anObject andProxy: aProxy
	| refStream fileName result | 
	fileName := (aProxy mareaFileNameFor: anObject).
	[ fileName := fileName, '.swap' ] 
		doWhileTrue: [(FileDirectory default isAFileNamed: fileName)].
	"all this thing of the result should be removed when the class serialization is working"
	result := self mareaSerializer mareaSerializeAndWriteObject: anObject to: fileName.
	aProxy mareaStoreFileNameIfNecessary: fileName result: result. 
	self mareaLog: 'The object ', anObject mareaPrintString, ' was written on file named: ', fileName.

! !

!ClassProxyHandler methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 1/17/2011 15:36'!
seeClassSide! !

ProtoObject subclass: #CompiledMethodProxyHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Methods'!

CompiledMethodProxyHandler class
	instanceVariableNames: 'MareaSerializer'!

CompiledMethodProxyHandler class
	instanceVariableNames: 'MareaSerializer'!

!CompiledMethodProxyHandler classSide methodsFor: 'constants' stamp: 'MarianoMartinezPeck 11/25/2010 10:11'!
loopTreshhold
	^ 10! !

!CompiledMethodProxyHandler classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 3/13/2011 12:37'!
mareaCheckLoop
	| ctxt runWithInMethodProxy runWithInMethodProxyReceiver proxySender found startingPoint loopCounter |

	ctxt := thisContext.
	loopCounter := 0.
	
	ctxt sender ifNil: [^ self].
	ctxt sender sender ifNil: [^ self].
	ctxt sender sender sender ifNil: [^ self].
	
	runWithInMethodProxy := ctxt sender sender method.
	runWithInMethodProxyReceiver :=  ctxt sender sender receiver. 
	proxySender := ctxt sender sender sender method.
	startingPoint := ctxt sender sender sender.
	
"	ToolSet inspect: ctxt sender sender sender label: 'where to start'. 
	ToolSet inspect: runWithInMethodProxy label: 'runWithInMethodProxy'.
	ToolSet inspect: runWithInMethodProxyReceiver label: 'runWithInMethodProxyReceiver'.
	ToolSet inspect: proxySender label: 'proxySender'."
	
	[startingPoint isNil ifFalse: [
		loopCounter := loopCounter + 1.
		found := startingPoint findContextSuchThat: [:aContext | 
			(aContext sender isNil not) and:  [
				(aContext sender method == proxySender) 
				and: [
					(runWithInMethodProxyReceiver == aContext receiver)
						and: [aContext method == runWithInMethodProxy ]]
			]
		].
		 found isNil ifFalse: [ startingPoint := found sender].
		]
	] doWhileTrue: [ (found isNil not and: [loopCounter < self loopTreshhold ]) and: [startingPoint isNil not] ].
	
	

	
	(loopCounter = self loopTreshhold) ifTrue: [ 
		self mareaLog: 'LOOP ---- ', ctxt sender sender tempsAndValues asString. 
		(PossibleLoopDetection with: ctxt sender sender tempsAndValues)
		signal: 'It is possible that a proxy that was needed to swap is, was swapped out.' ].
! !

!CompiledMethodProxyHandler classSide methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 1/17/2011 16:57'!
mareaHandleCannotInterpret: aMessage forProxy: aProxy
	| answer |
	self mareaLog: 'cannotInterpret: ', aMessage selector.
	self mareaUninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := aMessage sendTo: aProxy.
	self mareaLog: 'The message was sent to the original object'.
	^ answer 
! !

!CompiledMethodProxyHandler classSide methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 11/28/2010 20:15'!
mareaHandleDoesNotUnderstand: aMessage forProxy: aProxy

	| oldMethod answer |
	self mareaCheckLoop.
	self mareaLog: aProxy mareaClass name, ' dnu: ', aMessage selector.
	oldMethod := self mareaUninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := oldMethod perform: aMessage selector withArguments: aMessage arguments.
	self mareaLog: 'The message was sent to the original object'.
	^ answer.! !

!CompiledMethodProxyHandler classSide methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 11/28/2010 20:28'!
mareaHandleRun: aSelector with: arguments in: aReceiver forProxy: aProxy
	| aResult oldMethod |
	self mareaCheckLoop.
	self mareaLog: 'The method ', aSelector, ' is being executed with a receiver instance of ', aReceiver mareaClass name.
	oldMethod := self mareaUninstallForProxy: aProxy.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	self mareaLog: 'The method ', aSelector, ' was executed with a receiver instance of ', aReceiver mareaClass name.
	^aResult
	! !

!CompiledMethodProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/14/2011 19:40'!
mareaInstallFor: aMethodReference andProxy: anObject
	| oldMethod oldClass selector |
	oldClass := aMethodReference actualClass. 
	selector := aMethodReference  selector. 
	[oldMethod := oldClass lookupSelector: selector.
	oldMethod isNil ifTrue: [
		SelectorNotFoundError signal: ('The selector: ', aMethodReference  selector asString, 
		' was not found in the class: ', aMethodReference actualClass name asString)].
	"The other alternative is being able to create proxies for profies, but the proxy 
	handlers expect a CompiledMethod and not a proxy."
		oldMethod mareaIsProxy.
	] whileTrue: [oldMethod mareaUninstall].
	"oldMethod methodClass superclass isNil ifTrue: [self mareaLog: 'A CompiledMethod cannot be swapped out if the superclass of the class where it is installed is not a subclass of at least ProtoObject. Method: ', oldMethod mareaPrintString].    "
	self mareaLog: 'The method ', aMethodReference mareaPrintString, ' is being wrapped'.
	self mareaWriteObjectOnDisk: oldMethod andProxy: anObject.
	oldClass methodDict at: selector put: anObject.
	self mareaLog: 'The method ', aMethodReference mareaPrintString, ' was wrapped'.
	! !

!CompiledMethodProxyHandler classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 11/24/2010 12:13'!
mareaRemoveFile: aFileName
	FileDirectory default deleteFileNamed: aFileName
	
! !

!CompiledMethodProxyHandler classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/1/2010 17:58'!
mareaSerializer
	MareaSerializer isNil ifTrue: [MareaSerializer := ReferenceStreamMareaSerializer new].
	^ MareaSerializer! !

!CompiledMethodProxyHandler classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/1/2010 17:52'!
mareaSerializer: aMareaSerializer
	MareaSerializer := aMareaSerializer new! !

!CompiledMethodProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'mariano 11/27/2010 16:04'!
mareaUninstallForProxy: aProxy
	^ self mareaUninstallForProxy: aProxy ifNotInstalled: [ ProxyIsNotInstalled signal: 'The proxy is not installed. '].! !

!CompiledMethodProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/14/2011 19:36'!
mareaUninstallForProxy: aProxy ifNotInstalled: errorBLock
	| oldMethod |
	aProxy mareaIsProxyInstalled ifFalse: [ errorBLock value ].
	oldMethod := self mareaSerializer mareaUnserializeObjectFrom: aProxy mareaFileName.
"	oldMethod methodClass superclass isNil ifTrue: [self mareaLog: 'A CompiledMethod cannot be swapped out if the superclass of the class where it is installed is not a subclass of at least ProtoObject. Method: ', oldMethod mareaPrintString].    
	"self mareaLog: 'The CompiledMethod ', oldMethod mareaPrintString, ' was loaded form file.'.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	self mareaLog: 'The Proxy for ', oldMethod mareaPrintString, ' was uninstalled.'.
	self mareaRemoveFile: aProxy mareaFileName.
	aProxy mareaMarkAsUninstalled.
	^ oldMethod.  
! !

!CompiledMethodProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'mariano 11/27/2010 16:08'!
mareaUninstallIfNeeded: aProxy
	^ [self mareaUninstallForProxy: aProxy] on: ProxyIsNotInstalled do: [].! !

!CompiledMethodProxyHandler classSide methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 3/14/2011 19:40'!
mareaWriteObjectOnDisk: anObject andProxy: aProxy
	| refStream fileName | 
	fileName := (aProxy mareaFileNameFor: anObject).
	[ fileName := fileName, '.swap' ] 
		doWhileTrue: [(FileDirectory default isAFileNamed: fileName)].
	self mareaSerializer mareaSerializeAndWriteObject: anObject to: fileName.
	aProxy mareaStoreFileNameIfNecessary: fileName. 
	self mareaLog: 'The object ', anObject mareaPrintString, ' was written on file named: ', fileName.

! !

!CompiledMethodProxyHandler methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 11/25/2010 17:02'!
seeClassSide! !

ProtoObject subclass: #ObjectProxy
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Objects'!

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 15:39'!
aTest

| o p |
o := MyClass new.
o foo: 123.
p := ClassProxy3 new.
p become: MyClass.
MyClass flushCache.
ClassProxy3 flushCache.
o == nil.
Transcript show: o class name; cr.
o foo.
! !

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:51'!
forFileName: aFileName
	^ self new fileName: aFileName ! !

!ObjectProxy methodsFor: 'proxy' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
become: anObject
	self mareaSerializeAndWriteToDisk: anObject.
	"anObject becomeForward: self. "
	super become: anObject. ! !

!ObjectProxy methodsFor: 'catching' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
doesNotUnderstand: aMessage
	self mareaLog: 'Message not understood:', aMessage asString.
	self mareaLog: 'Will restore object'.
	self become: self mareaLoadBackSerializedObjectsFromFile.
	self mareaLog: 'Object was restored'.
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ObjectProxy methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaLoadBackSerializedObjectsFromFile

	| file result |
	file := FileStream fileNamed: fileName.
	file binary.
	result := (ReferenceStream on: file) next.
	file close.
	^ result! !

!ObjectProxy methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaSerializeAndWriteToDisk: anObject	
	| file result |
	fileName := (DateAndTime now asString, '.swap').
	file := FileStream fileNamed: fileName.
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.! !

ProtoObject subclass: #ObjectProxyHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Objects-CannotInterpret'!

ObjectProxyHandler class
	instanceVariableNames: 'MareaSerializer'!

ObjectProxyHandler class
	instanceVariableNames: 'MareaSerializer'!

!ObjectProxyHandler classSide methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 3/14/2011 10:34'!
mareaHandleCannotInterpret: aMessage for: aProxy
	| answer oldObject |
	self mareaLog: 'cannotInterpret: ', aMessage selector.
	oldObject := self mareaUninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := aMessage sendTo: oldObject.
	self mareaLog: 'The message was sent to the original object'.
	^ answer 
! !

!ObjectProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/13/2011 20:36'!
mareaInstallFor: anObject andProxy: aProxy
	| objectName  |
	["The other alternative is being able to create proxies for profies, but the proxy 
	handlers expect a Class and not a proxy."
	anObject mareaIsProxy.
	] whileTrue: [anObject mareaUninstall].

	objectName := anObject name.
	self mareaLog: 'The object ', objectName , ' is being wrapped'. 
	self mareaWriteObjectOnDisk: anObject andProxy: aProxy.
	aProxy become: anObject.
	ObjectProxyTrap adoptInstance: anObject.

	self mareaLog: 'The object ', objectName , ' was wrapped'.
! !

!ObjectProxyHandler classSide methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 3/13/2011 16:31'!
mareaLoadObjectFor: aProxy
	^ self mareaSerializer mareaUnserializeObjectFrom: aProxy mareaFileName
	! !

!ObjectProxyHandler classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 3/13/2011 18:09'!
mareaRemoveFile: aFileName
	FileDirectory default deleteFileNamed: aFileName
	
! !

!ObjectProxyHandler classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/13/2011 17:04'!
mareaSerializer
	MareaSerializer isNil ifTrue: [MareaSerializer := FuelMareaSerializer new].
	^ MareaSerializer! !

!ObjectProxyHandler classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/13/2011 12:20'!
mareaSerializer: aMareaSerializer
	MareaSerializer := aMareaSerializer new! !

!ObjectProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/13/2011 12:20'!
mareaUninstallForProxy: aProxy
	^ self mareaUninstallForProxy: aProxy ifNotInstalled: [ ProxyIsNotInstalled signal: 'The proxy is not installed. '].! !

!ObjectProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/13/2011 18:22'!
mareaUninstallForProxy: aProxy ifNotInstalled: errorBLock
	| oldObject |
	
	self mareaLog: 'Starting to uninstall.'.
	aProxy mareaIsProxyInstalled ifFalse: [ errorBLock value ].
	self mareaLog: 'Trying to load.'.
	oldObject := self mareaLoadObjectFor: aProxy.
	self mareaLog: 'The object ', oldObject name, ' was loaded form file.'.
	aProxy become: oldObject.
	"now oldClass points to the proxy and aProxy points to the old class"
	self mareaLog: 'The Proxy for ', aProxy name, ' was uninstalled.'.
	self mareaRemoveFile: oldObject mareaFileName.
	oldObject mareaMarkAsUninstalled.
	^ aProxy.  
! !

!ObjectProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/13/2011 12:20'!
mareaUninstallIfNeeded: aProxy
	^ [self mareaUninstallForProxy: aProxy] on: ProxyIsNotInstalled do: [].! !

!ObjectProxyHandler classSide methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 3/14/2011 19:42'!
mareaWriteObjectOnDisk: anObject andProxy: aProxy
	| refStream fileName | 
	fileName := (aProxy mareaFileNameFor: anObject).
	[ fileName := fileName, '.swap' ] 
		doWhileTrue: [(FileDirectory default isAFileNamed: fileName)].
	self mareaSerializer mareaSerializeAndWriteObject: anObject to: fileName.
	aProxy mareaStoreFileNameIfNecessary: fileName. 
	self mareaLog: 'The object ', anObject mareaPrintString, ' was written on file named: ', fileName.
! !

!ObjectProxyHandler methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 3/13/2011 12:20'!
seeClassSide! !

!ProtoObject methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 10/20/2010 11:33'!
class
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!ProtoObject methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/17/2010 19:53'!
mareaClass
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!MethodReference methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/28/2010 20:21'!
mareaPrintString
	^ self actualClass name, ' >> #', methodSymbol! !

Object subclass: #ClassProxySuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Classes'!

!ClassProxySuperclass methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 1/17/2011 17:04'!
cannotInterpret: aMessage
	^  ClassProxyHandler mareaHandleCannotInterpret: aMessage for: aMessage lookupClass receiver: self
	
	! !

Object subclass: #CompiledMethodSwapper
	instanceVariableNames: ''
	classVariableNames: 'Logger ProxyClass'
	poolDictionaries: ''
	category: 'Proxies-Methods'!

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/21/2010 15:14'!
classesNotToSwap

	| tooDangerousClasses coreClasses protoObjectSubclasses classesSpecialArray veryUsedClasses allClasses debuggingClasses nilSubclasses |

	"This are classes that are known as too dangerous."
	tooDangerousClasses := OrderedCollection new.
	(ClassBuilder new tooDangerousClasses) 
		do: [:each | Smalltalk globals at: each 
			ifPresent: [:present | tooDangerousClasses add: (Smalltalk at: each) ] 
			ifAbsent: []].
	
	"These classes because they are too core and used by the code to swapout itseld"
	coreClasses :=  {Array. Object. ProtoObject. Class. Message. MethodDictionary. CompiledMethod}. 

	"Subclasses of ProtoObject because they do not implement some methods that Object does and that are used by the swapping stuff."
	protoObjectSubclasses := ProtoObject subclasses.
	
	"These classes cannot be swapped because they are used by the VM"
	classesSpecialArray := Smalltalk specialObjectsArray select: [ :each | each isBehavior ].
	
	"These classes cannot be swapped because they install the segment (they are used) even before the segment can be written into a file"
	veryUsedClasses := { Cursor. CursorWithMask. EncodedCharSet.}.
	
	"Classes that are usually needed to debug and they help us to analyze problems"
	debuggingClasses := { DEVToolSet. }.
	
	"nil subclasses cannot be swapped out because since they don't subclass ProtoObject they may not even implement doesNotUnderstand:.
	For example, if we swap a CompiledMethod of PseudoContext, and then we try to load it back, the VM will crash with the error Recursive not understood error encountered. '"
	nilSubclasses := nil subclasses.
	
	allClasses := coreClasses, protoObjectSubclasses, classesSpecialArray, veryUsedClasses, tooDangerousClasses, debuggingClasses, nilSubclasses.
	
	^ allClasses asOrderedCollection ! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2010 17:53'!
compiledMethodsToSwap
	|  methodsToSwap classesNotToSwap packagesNotToSwap fixedMethodsNotToSwap |
	
	UnusedObjectDiscoverer current startDiscovery. 
	
	self discoverMinimalUsedCompiledMethods.
	self methodsUsedByMareaTesting.
	
	packagesNotToSwap := self packagesNotToSwap.
	
	classesNotToSwap := self classesNotToSwap.
	packagesNotToSwap do: [:aPackage | classesNotToSwap addAll: aPackage classes ].
	
	fixedMethodsNotToSwap := self fixedMethodsNotToSwap.
	fixedMethodsNotToSwap do: [:aMethod | 	UnusedObjectDiscoverer current primitiveSetUsedBit: aMethod boolean: true].
	
	classesNotToSwap do: [:aClass | aClass markAllInstanceAndClassMethodsAsUsed].
	
	UnusedObjectDiscoverer current stopDiscovery.
	
	methodsToSwap := CompiledMethod unusedInstances.
	Transcript show: 'Methods to swap: ',  methodsToSwap size asString; cr.
	Transcript show: 'Methods NOT to swap: ',  CompiledMethod usedInstances size asString; cr.
	
	^ methodsToSwap


! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/27/2010 17:05'!
discoverMinimalUsedCompiledMethods
"These the minimal CompiledMethods needed to install and install a CompiledMethodProxy"
	| aProxy |
	
	SystemNavigation default browseClass: Object.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	(ClassWith1Var methodDict at: #foo) literals.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	ClassWith1Var new foo.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/24/2011 10:42'!
exampleSwapOutAllUnusedMethods 
	"self nose"
	| methodsToSwap timeToInstall timeToUninstall counter |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. 
	self proxyClass: CompiledMethodProxySmallInteger.
	self proxyClass runningTest: false.
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	"self printSpaceTally.
"	methodsToSwap := self compiledMethodsToSwap.
	
	CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. 
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	
	counter := 0.
	[timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| 
		(counter \\ 5000) isZero ifTrue: [
			self log: ''.
			"self log: SmalltalkImage current vmStatisticsReportString."
			self log: ''.
		]. 
		counter := counter + 1.
		self installOn: method methodClass selector: method selector.].
	].

	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.

"	timeToUninstall := MessageTally time: [
		counter := 0.
		self proxyClass mareaAllInstalledProxies do: [:instance| 
			(counter \\ 5000) isZero ifTrue: [
				self log: ''.
				self log: SmalltalkImage current vmStatisticsReportString.
				self log: ''.
				self printSpaceTally.
			]. 
		counter := counter + 1.
		instance mareaUninstallIfNeeded
		].		
	]."
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	"self printSpaceTally."
	] ensure: [
		self log: 'Ensure....'.
		MareaLogger changeToFileLogger.
		"self proxyClass mareaUninstallIfNeededAllInstances."
"		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."
	]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/13/2011 12:45'!
exampleSwapOutAllUnusedMethodsAndClasses
	"self nose"
	| methodsToSwap timeToInstall timeToUninstall counter |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. 
	self proxyClass: CompiledMethodProxySmallInteger.
	self proxyClass runningTest: false.
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Methods Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Class Proxies installed instances before start: ', ClassProxy mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Classes instances before start: ', Smalltalk allClassesAndTraits size asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	"self printSpaceTally.
"	methodsToSwap := self compiledMethodsToSwap.
	
	CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. 
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	
	counter := 0.
	[timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| 
		(counter \\ 5000) isZero ifTrue: [
			self log: ''.
			"self log: SmalltalkImage current vmStatisticsReportString."
			self log: ''.
		]. 
		counter := counter + 1.
		self installOn: method methodClass selector: method selector.].
	].

	Smalltalk allClassesDo: [:aClass | aClass hasAllMethodsAsProxies ifTrue: [ClassProxy installOn: aClass ]. ].

	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Methods Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	self log: 'Class Proxies intalled: ',  ClassProxy  mareaAllInstalledProxiesCount asString.
	self log: 'Class instances after installing: ', Smalltalk allClassesAndTraits size asString.
	
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.

"	timeToUninstall := MessageTally time: [
		counter := 0.
		self proxyClass mareaAllInstalledProxies do: [:instance| 
			(counter \\ 5000) isZero ifTrue: [
				self log: ''.
				self log: SmalltalkImage current vmStatisticsReportString.
				self log: ''.
				self printSpaceTally.
			]. 
		counter := counter + 1.
		instance mareaUninstallIfNeeded
		].		
	]."
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Method Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Class Proxies installed instances after uninstalling: ', ClassProxy  mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	self log: 'Class instances after uninstalling: ', Smalltalk allClassesAndTraits size asString.
	"self printSpaceTally."
	] ensure: [
		self log: 'Ensure....'.
		MareaLogger changeToFileLogger.
		"self proxyClass mareaUninstallIfNeededAllInstances."
"		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."
	]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2010 15:02'!
exampleSwapOutUnusedTests
	"self exampleSwapOutUnusedTests"
	| methodsToSwap timeToInstall timeToUninstall |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. 
	self proxyClass: CompiledMethodProxySmallInteger.
	MareaLogger changeToFileLogger.
	Logger := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	methodsToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'Test'] ) do: [:aPackage |
		aPackage classes do: [:aClass |
			methodsToSwap addAll: aClass unusedMethods
			].
		].
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	[
	timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| self installOn: method methodClass selector: method selector.].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/28/2010 23:30'!
fixedMethodsNotToSwap
	^ self selectorsNotToSwap
		inject: OrderedCollection new
		into: [:allMethods :aSelector | 
			allMethods addAll: 
				((SystemNavigation default allImplementorsOf: aSelector) 
					collect: [:aMethodReference | aMethodReference compiledMethod ] ); yourself 
		]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:27'!
installOn: aClass selector:  aSelector.
	^ self proxyClass installOn: aClass selector: aSelector.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackages
	^ self listOfCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^  #('MultilingualTests' 'Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'Tests' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'ToolsTest' 'Gofer-Core' 'Gofer-Tests' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'Tests-VM' 'System-Change Notification' 'System' 'Tests-ObjectsAsMethods' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'MorphicTests' 'System-Serial Port' 'NetworkTests' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Tests-PrimCallController' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'KernelTests' 'System-FileRegistry' 'Tests-Bugs' 'ToolBuilder-SUnit' 'Tests-Release' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'CompilerTests' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Tests-SystemChangeNotification' 'GraphicsTests' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'FreeTypeTests' 'Settings-Monticello' 'HelpSystem-Tests' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'CollectionsTests' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfNotDangerousCorePackages
	^ self listOfNotDangerousCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/22/2010 21:40'!
listOfNotDangerousCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^ #('Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'Gofer-Core' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'System-Change Notification' 'System' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'System-Serial Port' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'System-FileRegistry' 'ToolBuilder-SUnit' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'Settings-Monticello' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2010 13:27'!
log: aString
	self logger log: aString ! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2010 13:32'!
logger	
	Logger isNil ifTrue: [
		Logger := FixesFileNameLoggerStrategy named: 'Swapper.txt'.
		Logger startLogging].
	^ Logger! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2010 18:09'!
methodsUsedByMareaTesting
	| suite |
	suite := TestSuite named: 'zaraza'. 
	AbstractCompiledMethodProxyTest withAllSubclasses do: [:each |
		TestCase addTestsFor: each name toSuite: suite.].
	suite tests: (suite tests reject: [:each | each testSelector = #testCompiledMethodProxyAndGC]). 
	suite run. 
 ! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/7/2010 16:40'!
nose 
	"self nose"
	| methodsToSwap timeToInstall timeToUninstall counter |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. 
	self proxyClass: CompiledMethodProxySmallInteger.
	self proxyClass runningTest: false.
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	"self printSpaceTally.
"	methodsToSwap := self compiledMethodsToSwap.
	
	CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. 
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	
	counter := 0.
	[timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| 
		(counter \\ 5000) isZero ifTrue: [
			self log: ''.
			"self log: SmalltalkImage current vmStatisticsReportString."
			self log: ''.
		]. 
		counter := counter + 1.
		self installOn: method methodClass selector: method selector.].
	].

	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.

"	timeToUninstall := MessageTally time: [
		counter := 0.
		self proxyClass mareaAllInstalledProxies do: [:instance| 
			(counter \\ 5000) isZero ifTrue: [
				self log: ''.
				self log: SmalltalkImage current vmStatisticsReportString.
				self log: ''.
				self printSpaceTally.
			]. 
		counter := counter + 1.
		instance mareaUninstallIfNeeded
		].		
	]."
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	"self printSpaceTally."
	] ensure: [
		self log: 'Ensure....'.
		MareaLogger changeToFileLogger.
		"self proxyClass mareaUninstallIfNeededAllInstances."
"		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."
	]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/19/2010 20:02'!
nose2 
	| minimalCompiledMethods |
	minimalCompiledMethods := self discoverMinimalUsedCompiledMethods.
	TestRunner methods do: [ :aMethod |
			CompiledMethodProxyReferenceStream installOn: TestRunner selector: aMethod selector.
			]. 
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/29/2010 00:01'!
packagesNotToSwap.

	^ (# ('System-Object Storage' 'Fuel' 'Kernel' 'Graphics' 'Exceptions' 'Proxies' 'Settings' 'System' 'UsedObject' 'Traits' 'Balloon' 'Tools' 'Morphic') collect: [:aPackageName | PackageInfo named: aPackageName]),
	(PackageInfo allPackages select: [:each | each packageName includesSubString: 'Collections-' ])
	! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/2/2010 16:04'!
printSpaceTally
	self log: ''.
	self log: ''.
	SpaceTally new printSpaceAnalysis: 1 on: self logger logFile maxResults: 10. 
	self log: ''.
	self log: ''.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:24'!
proxyClass
	^ ProxyClass! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:25'!
proxyClass: aProxyClass
	ProxyClass := aProxyClass.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/1/2010 10:19'!
selectorsNotToSwap
	^ #(#class), (Smalltalk specialObjectsArray select: [:each | each isSymbol])! !

Object subclass: #MareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Serializers'!

MareaSerializer subclass: #FuelMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Serializers'!

!FuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 3/13/2011 13:42'!
mareaSerializeAndWriteObject: anObject to: aFileName
	| serializer aFileStream | 
	aFileStream := (StandardFileStream fileNamed: aFileName) binary.
	serializer := FLSerializer on: aFileStream.
	serializer serialize: anObject.
	aFileStream close.
	self mareaLog: 'The object ', anObject name, ' was written on file'.
! !

!FuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 3/13/2011 18:08'!
mareaUnserializeObjectFrom: aFileName
	| materializer aFileStream |
	aFileStream := (StandardFileStream fileNamed: aFileName) binary.
	materializer := FLMaterializer on: aFileStream.
	materializer materialize.
	aFileStream close.
	^ materializer root
! !

MareaSerializer subclass: #ImageSegmentMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Serializers'!

!ImageSegmentMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 1/19/2011 14:44'!
mareaSerializeAndWriteClass: aClass to: aFileName
	| segment | 
	segment := ImageSegment new
		copyFromRoots: (Array with: aClass with: aClass class)
		sizeHint: 5000
		areUnique: true.
	segment segmentName: aFileName.
	FileStream forceNewFileNamed: aFileName do: 
		[ :stream | segment writeForExportOn: stream ].
	self mareaLog: 'The class ', aClass name, ' was written on file'.
	^ segment.


"mareaSerializeAndWriteClass: aClass to: aFileName
	| segment | 
	segment := ImageSegment new
		copyFromRoots: (Array with: aClass)
		sizeHint: 5000
		areUnique: true.
	segment extract.
	segment segmentName: aFileName.
	segment writeToFile.
	self mareaLog: 'The class ', aClass name, ' was written on file'.
	^ segment.
"! !

!ImageSegmentMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 1/19/2011 14:44'!
mareaUnserializeClassFrom: aFileName result: aResult
	| stream |
	stream := FileStream oldFileNamed: aFileName.
	^ stream fileInObjectAndCode arrayOfRoots first
	

"mareaUnserializeClassFrom: aFileName result: aResult
	^ aResult install arrayOfRoots first. 
	"! !

MareaSerializer subclass: #ImageSegmentSwapMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Serializers'!

!ImageSegmentSwapMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 1/19/2011 14:45'!
mareaSerializeAndWriteClass: aClass to: aFileName
	| segment | 
	segment := ImageSegment new
		copyFromRoots: (Array with: aClass)
		sizeHint: 5000
		areUnique: true.
	segment extract.
	segment segmentName: aFileName.
	segment writeToFile.
	self mareaLog: 'The class ', aClass name, ' was written on file'.
	^ segment.! !

!ImageSegmentSwapMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 1/19/2011 14:45'!
mareaUnserializeClassFrom: aFileName result: aResult
	^ aResult install arrayOfRoots first. 
! !

!MareaSerializer methodsFor: 'API' stamp: 'MarianoMartinezPeck 3/14/2011 19:08'!
mareaSerializeAndWriteObject: anObject to: aFileName
	self shouldBeImplemented ! !

!MareaSerializer methodsFor: 'API' stamp: 'MarianoMartinezPeck 3/14/2011 19:09'!
mareaUnserializeObjectFrom: aFileName
	self shouldBeImplemented ! !

MareaSerializer subclass: #ReferenceStreamMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Serializers'!

!ReferenceStreamMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 3/14/2011 19:03'!
mareaSerializeAndWriteObject: anObject to: aFileName
	| refStream | 
	refStream := ReferenceStream fileNamed: aFileName.
	refStream nextPut: anObject.
	refStream close.
	self mareaLog: 'The object ', anObject name, ' was written on file'.
! !

!ReferenceStreamMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 3/14/2011 19:02'!
mareaUnserializeObjectFrom: aFileName
	| refStream aClass |
	refStream := ReferenceStream fileNamed: aFileName.
	aClass := refStream next.
	refStream close.
	^ aClass! !

!Object methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/14/2011 19:42'!
mareaPrintString
	^ self printString! !

Object subclass: #ObjectProxyCannotInterpret
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Objects-CannotInterpret'!

ObjectProxyCannotInterpret class
	instanceVariableNames: 'IsRunnintTests'!

ObjectProxyCannotInterpret class
	instanceVariableNames: 'IsRunnintTests'!

!ObjectProxyCannotInterpret classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/13/2011 19:24'!
installOn: anObject
	| newProxy originalProxy |
	newProxy := self new.
	originalProxy := newProxy mareaInstallFor: anObject.
	ObjectProxyTrap nilMethodDict.! !

!ObjectProxyCannotInterpret classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/13/2011 20:26'!
isRunningTest
	IsRunnintTests isNil ifTrue: [IsRunnintTests := true].
	^ IsRunnintTests ! !

!ObjectProxyCannotInterpret classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/13/2011 12:58'!
runningTest: aBoolean
	IsRunnintTests := aBoolean  ! !

!ObjectProxyCannotInterpret methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 3/14/2011 15:04'!
cannotInterpret: aMessage
	| result |
	"I need to do this first because self is still pointing to the object whose class methodDict is nil. So if I dont do this, I cannot send any message to self because otherwise there will be a infinitive loop"
	ObjectProxyCannotInterpret adoptInstance: self. 
	self mareaLog: 'Object cannot interpret message: ', aMessage selector.
	(self mareaShouldInterpretMessage: aMessage selector)
		ifTrue: [
				result := self mareaInterpretMessage: aMessage.
				"Here we can interpret two kind of messages, those that start with the prefix marea and the special message #class. If the message is #class it is possible that the proxy was uninstalled, so we need to put back the trap only if it was not"
				self mareaIsProxy ifTrue: [ObjectProxyTrap adoptInstance: self].
				^ result ]
		ifFalse: [ ^ ObjectProxyHandler mareaHandleCannotInterpret: aMessage for: self ]
	
	! !

!ObjectProxyCannotInterpret methodsFor: 'class membership' stamp: 'MarianoMartinezPeck 3/13/2011 18:37'!
class
	((self mareaClass isRunningTest) or: [self mareaIsProxyInstalled not])
		ifTrue: [^ self mareaClass ]
		ifFalse: [ ^ self mareaUninstall class ].
	! !

!ObjectProxyCannotInterpret methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/13/2011 16:30'!
mareaFileName
	^ number asString, '.swap'! !

!ObjectProxyCannotInterpret methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/14/2011 19:18'!
mareaFileNameFor: aCompiledMethod
	number := SmallInteger mareaNextNumber.
	^  number asString! !

!ObjectProxyCannotInterpret methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/13/2011 12:58'!
mareaInstallFor: anObject
	ObjectProxyHandler mareaInstallFor: anObject andProxy: self
	! !

!ObjectProxyCannotInterpret methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 3/14/2011 14:44'!
mareaInterpretMessage: aMessage
	| answer |
	self mareaLog: 'The message ', aMessage selector, ' was understood '.
	answer := aMessage sendTo: self. 
	self mareaLog: 'The message ', aMessage selector, ' was sent to the object'.
	^ answer! !

!ObjectProxyCannotInterpret methodsFor: 'testing' stamp: 'MarianoMartinezPeck 3/13/2011 16:34'!
mareaIsProxy
	^ true! !

!ObjectProxyCannotInterpret methodsFor: 'testing' stamp: 'MarianoMartinezPeck 3/13/2011 16:28'!
mareaIsProxyInstalled
	^ number isNil not! !

!ObjectProxyCannotInterpret methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/13/2011 16:30'!
mareaMarkAsUninstalled
	number := nil.! !

!ObjectProxyCannotInterpret methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 3/14/2011 10:29'!
mareaShouldInterpretMessage: aSelector
	^ (aSelector beginsWith: 'marea') or: [aSelector = #class]
	! !

!ObjectProxyCannotInterpret methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/13/2011 13:43'!
mareaStoreFileNameIfNecessary: aFileName! !

!ObjectProxyCannotInterpret methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/13/2011 16:34'!
mareaUninstall
	^ ObjectProxyHandler mareaUninstallForProxy: self
! !

!ObjectProxyCannotInterpret methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/13/2011 16:34'!
mareaUninstallIfNeeded
	^ ObjectProxyHandler mareaUninstallIfNeeded: self
! !

ObjectProxyCannotInterpret subclass: #ObjectProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Objects-CannotInterpret'!

!ObjectProxyTrap classSide methodsFor: 'method dictionary' stamp: 'MarianoMartinezPeck 3/13/2011 19:24'!
nilMethodDict
	methodDict := nil. ! !

Object subclass: #ObjectSwapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Objects'!

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/21/2010 18:26'!
fileName
	^ DateAndTime now asString , '.swap'! !

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaSerializeAndWriteToDisk: anObject
	| file fileName result |
	fileName := self fileName.
	file := FileStream fileNamed: fileName.
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.
	^ fileName! !

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
swap: anObject
	| fileName proxy |
	fileName := self mareaSerializeAndWriteToDisk: anObject. 
	
	"make this nicer"
	anObject isBehavior 
		ifTrue: [proxy := AClassProxy forFileName: fileName.]
		ifFalse: [proxy := ObjectProxy forFileName: fileName.].
	
	anObject becomeForward: proxy. ! !

Error subclass: #PossibleLoopDetection
	instanceVariableNames: 'arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Errors'!

!PossibleLoopDetection classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 11/25/2010 11:14'!
with: arguments
	^ self new initializeWith: arguments ! !

!PossibleLoopDetection methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/25/2010 11:15'!
arguments 
	^ arguments ! !

!PossibleLoopDetection methodsFor: 'initialize' stamp: 'MarianoMartinezPeck 11/25/2010 11:15'!
initializeWith: aListOfArguments 
	arguments := aListOfArguments! !

Error subclass: #ProxyIsNotInstalled
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Errors'!

Error subclass: #SelectorNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Errors'!
SmallInteger initialize!
CompiledMethodProxy initialize!
CompiledMethodProxySmallInteger initialize!
